<?php
/**
* @version 			SEBLOD 3.x Core
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2013 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

use Joomla\Registry\Registry;

defined( '_JEXEC' ) or die;

JCckDev::initScript( 'link', $this->item );

JCckDev::forceStorage();

$options	=	JCckDev::fromSTRING( $this->item->options );
$options2	=	JCckDev::fromJSON( $this->item->options2 );

require_once JPATH_ADMINISTRATOR.'/components/com_cck/helpers/helper_admin.php'; //todo: >> core_storage_location
$dynamic=JText::_( 'PLG_CCK_FIELD_LINK_'.$this->item->name.'_STATIC' );

$path = '/plugins/cck_field_link/content_menu_dynamic/';
//$f = JCckDev::get('core_dev_select', '', $config, array( 'defaultvalue'=>0, 'label'=>JText::_( 'FIELD_LINK_'.$this->item->name.'_FILESAVE' ), 'selectlabel'=>'', 'options'=>'Yes=1||No=0', 'storage_field'=>'fsave' ));

echo '<div style="width:100%;"><ul class="adminformlist ">';
echo JCckDev::renderForm( 'core_bool4', $this->item->bool4, $config, array( 'label'=>JText::_( 'FIELD_LINK_'.$this->item->name.'_STATIC' ), 'options'=>'No=0||Yes=1' ) );
echo "</ul></div>";
echo '<div class="seblod">';
echo '<ul class="adminformlist adminformlist-2cols">';
echo JCckDev::renderForm( 'core_bool3', $this->item->bool3, $config, array( 'label'=>JText::_( 'FIELD_LINK_'.$this->item->name.'_LANG' ), 'options'=>'No=0||Yes=1' ) );
echo JCckDev::renderForm( 'core_sef', '', $config, array( 'selectlabel'=>'Inherited', 'storage_field'=>'sef' ) );
echo "</div>";

echo '<div id="nodynamicmenu"><div class="seblod">';
echo '<ul class="adminformlist adminformlist-2cols">';
//echo JCckDev::renderForm( 'core_menuitem', '', $config, array( 'selectlabel'=>'Inherited' ) );
echo JCckDev::renderForm( 'core_menuitem', '', $config, array( 'selectlabel'=>'Inherited', 'options'=>'Use Mapping=optgroup||Fields=-3||Use Value=optgroup||Field=-2' ) );
echo JCckDev::renderForm( 'core_dev_select', '', $config, array( 'defaultvalue'=>'', 'label'=>'Content', 'selectlabel'=>'Current', 'options'=>'Use Value=optgroup||Field=2', 'storage_field'=>'content' ) );
	
echo JCckDev::renderForm( 'core_dev_text', '', $config, array( 'label'=>'Field Name', 'storage_field'=>'content_fieldname' ) );

echo JCckDev::renderBlank( '<input type="hidden" id="blank_li" value="" />' );
	
echo JCckDev::renderForm( 'core_storage_location', '', $config, array( 'label'=>'Content Object', 'storage_field'=>'content_location' ) );


echo '</ul></div></div><div id="dynamicmenu"><div class="seblod">';
echo '<ul class="adminformlist adminformlist-2cols">';
echo JCckDev::renderForm( 'core_dev_select', '', $config, array( 'defaultvalue'=>'', 'label'=>JText::_( 'FIELD_LINK_'.$this->item->name.'_ISREGEX' ), 'selectlabel'=>'', 'options'=>'Yes=1||No=0', 'storage_field'=>'isregex' ) );

echo JCckDev::renderForm( 'core_bool', $this->item->bool, $config, array( 'label'=>'Mode', 'options'=>'noCode=1||Code=0' ) );
echo '</ul></div>';


echo '<div id="code_options"><div class="seblod">';
echo '<ul class="adminformlist adminformlist-2cols">';
//echo JCckDev::renderBlank( '<input type="hidden" id="blank_li" value="" />' );
echo JCckDev::renderForm( 'core_dev_select', '', $config, array( 'defaultvalue'=>0, 'label'=>JText::_( 'FIELD_LINK_'.$this->item->name.'_ISFILECODE' ), 'selectlabel'=>'', 'options'=>'Yes=1||No=0', 'storage_field'=>'isFcode' ) );

echo JCckDev::renderForm( 'core_dev_textarea', '', $config, array( 'label'=>JText::_( 'FIELD_LINK_'.$this->item->name.'_CODE' ), 'cols'=>92, 'rows'=>8, 'storage_field'=>'freeCode' ), array(), 'w100 freecode' );

echo JCckDev::renderForm( 'core_options', '', $config, array( 'label'=>'Files','storage_field'=>'fileCode' ),array(),'fcode' );

echo "</ul></div></div>";


echo "<div id='no_code_options'>";
?>
	<div class="seblod">
		<?php echo JCckDev::renderLegend( JText::_( 'COM_CCK_CONSTRUCTION' ), JText::_( 'PLG_CCK_FIELD_LINK_'.$this->item->name.'_DESC' ) ); ?>
	    <ul class="adminformlist adminformlist-2cols">
	        <?php
	        
	        echo JCckDev::renderForm( 'core_dev_select', '', $config, array( 'defaultvalue'=>0, 'label'=>JText::_( 'FIELD_LINK_'.$this->item->name.'_FILESAVE' ), 'selectlabel'=>'', 'options'=>'Yes=1||No=0', 'storage_field'=>'fsave' ) );
			
		
			$db			=& JFactory::getDBO();
			$query="select name, title from #__cck_core_types where published = 1 order by title asc";
			$db->setQuery($query);
			$result = $db->loadRowList();
			
			$selectCck='
			<select class="celCck" name="selCck">';
			foreach($result as $res){
				$selectCck.='<option value="'.$res[0].'">'.$res[1].'</option>';
			}
			$selectCck.='</select>';
			
			$query="select id, title from #__usergroups";
			$db->setQuery($query);
			$result = $db->loadRowList();
			
			$selectGroupUser='
			<select class="groupUser" name="groupUser"><option value=0>select</option>';
			foreach($result as $res){
				$selectGroupUser.='<option value="'.$res[0].'">'.$res[1].'</option>';
			}
			$selectGroupUser.='</select>';
			
			$selectId =  JCckDev::renderForm( 'core_sef', '', $config, array( 'selectlabel'=>'Inherited', 'storage_field'=>'selectId' ) );
			$selectId = str_replace('class="', 'class="selectId ', $selectId);
/*
			$selectId='
			<select class="selectId" name="selectId">
				<option value="0">Hérité</option>
				<option value="1">forcer url: ID-alias</option>
				<option value="2">forcer url: alias</option>
			</select>';
*/			
			$menu=JCckDev::renderForm( 'core_menuitem', '', $config, array( 'selectlabel'=>'Inherited' ) );
			$menu = str_replace('class="', 'class="menuItem "', $menu);
			$menu=str_replace('<ul>', '', $menu);
			$menu=str_replace('</ul>', '', $menu);
			$menu=str_replace('</li>', '', $menu);
			$menu=str_replace('<li>', '', $menu);
		
			echo '<div class="intitule"  style="clear:both;width:100%;margin-bottom:2%;"><div style="float:left;width:25%;">'.JText::_('ACL').'</div>';
			echo '<div style="float:left;width:25%;">'.JText::_('COM_CCK_FIELD_LINK_CONTENT_MENU_DYNAMIC_CONTENT_TYPE').'</div>';
			echo '<div style="float:left;width:25%;">'.JText::_('COM_CCK_FIELD_LINK_CONTENT_MENU_DYNAMIC_FILTER_FIELDNAME').'</div>';
			echo '<div style="float:left;width:25%;">'.JText::_('COM_CCK_FIELD_LINK_CONTENT_MENU_DYNAMIC_FILTER_VALUE').'</div>';
			echo '</div>';
			
			echo '<div id="sortable">';
			echo '<div class="multiple ui-state-default" style="clear:both;margin-bottom:3%;min-height:70px;">';
			echo '<div style="float:left">'.$selectGroupUser.' '.$selectCck.' </div>&nbsp;&nbsp;&nbsp;&nbsp;';
			
			$db		=	JFactory::getDBO();
			$query	=	'select DISTINCT(title) AS title, name AS value from #__cck_core_fields WHERE published = 1 ORDER BY title ASC';
			$db->setQuery( $query );
			$result=$db->loadObjectList();
			
			$selectField = '<select class="filter_field" name="filter_field">';
			foreach($result AS $row){
				$selectField .= "<option value=".$row->value.">".$row->title."</option>";
			}
			$selectField .= '</select>';
			echo $selectField;
			echo '<input type="text" class="filter_field_value" name="filter_field_value" value="" class="inputbox text" size="25%">';
			echo $menu.' '.$selectId;//
			$path = '/plugins/cck_field_link/content_menu_dynamic/';
			$html	=	'';
			$html	.=	'<div class="button-del">'
					.		'<img id="button_del__0" class="button-del" src="'.$path.'assets/images/del-default.gif" alt="Del"/>'
							.	'</div> ';
			
			$html	.=	'<div class="button-add">'
					.		'<img id="button_add" class="button-add" src="'.$path.'assets/images/add-default.gif" alt="Add"/> '
							.	'</div> ';
			$html	.=	'<div class="button-drag">'
						.		'<img id="button_drag" src="'.$path.'assets/images/drag-default.gif" alt="Drag"/>'
						.	'</div> ';
			$html	.=	'<p>&nbsp;</p>';
			$html	.= '</div>';
			echo $html;

	
			echo JCckDev::renderForm( 'core_defaultvalue_textarea', $options, $config );
			echo JCckDev::renderForm( 'core_cck', $options, $config );		
			echo '</div>';
			echo JCckDev::renderSpacer( JText::_( 'COM_CCK_CONSTRUCTION' ) . '<span class="mini">('.JText::_( 'COM_CCK_GENERIC' ).')</span>' );
			echo JCckDev::renderForm( 'core_dev_text', '', $config, array( 'label'=>'Class', 'size'=>24, 'storage_field'=>'class' ) );
			echo JCckDev::renderForm( 'core_dev_text', '', $config, array( 'label'=>'Rel', 'size'=>32, 'storage_field'=>'rel' ) );
			echo JCckDev::renderForm( 'core_options_target', '', $config, array( 'defaultvalue'=>'', 'selectlabel'=>'Inherited', 'storage_field'=>'target' ) );
			echo JCckDev::renderForm( 'core_tmpl', '', $config );
			echo JCckDev::renderForm( 'core_dev_textarea', '', $config, array( 'label'=>'Custom variables', 'cols'=>92, 'rows'=>1, 'storage_field'=>'custom' ), array(), 'w100' );
	        
			$css_s	=	$path . 'assets/css/style.css';
	        ?>
	    </ul>
	</div>
</div>
</div>

<link rel="stylesheet" href="<?php  echo $css_s; ?>" type="text/css" />


<?php
JCck::loadjQuery();
JCck::loadjQueryUI();


?>

<script>
function multipliezMoi(thisisit){
    jQuery( ".multiple:last" ).clone(true).insertAfter(jQuery( ".multiple:last" ));
	var number = 1 + Math.floor(Math.random() * 999999999);
	jQuery( ".multiple:last" ).attr('id', 'v'+number);
	jQuery( ".kill:last" ).removeClass().addClass('kill v'+number);
}
function defoncezMoi(thisisit){
	jQuery(thisisit).closest('.multiple').remove()
	
}

function submitCusto(){
	// check if code or not code, if not code, pushFull
	var noCode = jQuery("#bool").val();
	if(noCode){
		pushFull();
	}
}

function pushFull(){

	var result = [];
	jQuery('.celCck').each(function () {
		// contentType => cT
		result.push({cT : jQuery(this).val()});
	});
	var i=0;
	jQuery('.filter_field').each(function () {
		// filter_field => ff
		result[i].ff = jQuery(this).val();
		i++;
	});

	i=0;
	jQuery('.filter_field_value').each(function () {
		// filter_field_value => ffv
		result[i].ffv = jQuery(this).val();
		i++;
	});
	i=0;
	jQuery('.selectId').each(function () {
		// selectId => sId
		result[i].sId = jQuery(this).val();
		i++;
	});
	i=0;
	jQuery('.groupUser').each(function () {
		// groupUser => gu
		result[i].gu = jQuery(this).val();
		i++;
	});
	i=0;
	jQuery('.multiple #itemid').each(function () {
		// itemId => iId
		result[i].iId = jQuery(this).val();
		i++;
	});

	// here, if config save in file, change defaultValue
	var defaultVal = JSON.stringify(result);
	var fsave = jQuery('#fsave').val();
	if(fsave == 1){
		var viewid = jQuery('#myid',window.parent.document).val();		
		var view = jQuery('#element',window.parent.document).val();
		var fieldid = '<?php echo $this->item->id; ?>';
		
		jQuery.ajax({
			url: "<?php echo JURI::root().'index.php?option=com_ajax&plugin=content_menu_dynamic&group=cck_field_link&format=json';?>",
	//layout=autocomplete",
			type: "POST",
			dataType: "json",
			data: {task: "_setCustomConf",view: view,fieldId: fieldid,viewId: viewid,conf: defaultVal},
			success: function(data) {
				var success = data["success"];
				jQuery('#defaultvalue').val(view +'_'+ fieldid +'_'+ viewid);
			}
		});
	}else{
		jQuery('#defaultvalue').val(defaultVal);
	}	
}
var oncl=jQuery('#submitBox').attr('onclick');
jQuery('#submitBox').attr('onclick', 'submitCusto();'+oncl);

	
</script>


<script type="text/javascript">
jQuery(document).ready(function($) {

	function modifDynamic(){
		var isDynamic = jQuery('#bool4').val() == 1;
		console.log("isdynamic => "+isDynamic);
		jQuery('#nodynamicmenu').css('display', isDynamic ? 'none' : 'block');
		jQuery('#dynamicmenu').css('display',isDynamic ? 'block' : 'none');
		
	}
	
	function modifCode(){
		var isCode = jQuery('#bool').val() == 0;
		jQuery('#no_code_options').css('display', isCode ? 'none' : 'block');
		jQuery('#code_options').css('display',isCode ? 'block' : 'none');
		if(isCode){
			modifIsFCode();
		}else{
			console.log("init No Code");
			initNoCode();
		}
		return isCode;
	}
	
	function modifIsFCode(){
		var isFcode = jQuery('#isFcode').val() == 1;
		jQuery('.freecode').css('display', isFcode ? 'none' : 'block');
		jQuery('.fcode').css('display',isFcode ? 'block' : 'none');
		console.log('isFcode = '+isFcode);
		return isFcode;
	}
	
	function initNoCode(){
		jQuery('#defaultvalue').removeAttr('maxlength');
		jQuery('#defaultvalue').removeClass('validate[maxSize[255]]');
	
		$('#defaultvalue').hide();
		$('#defaultvalue').prev().hide();
		var number = 1 + Math.floor(Math.random() * 999999999);
		jQuery( ".multiple:last" ).attr('id', 'v'+number);
		jQuery( ".kill:last" ).removeClass().addClass('kill v'+number);
	
		var defaultValue = $('#defaultvalue').val();
	
		console.log("old default value => "+defaultValue);
		// here, if config save in file, change defaultValue
		var fsave = $('#fsave').val();
		if(fsave == 1){
			var viewid = $('#myid',window.parent.document).val();		
			var view = $('#element',window.parent.document).val();
			var fieldid = '<?php echo $this->item->id; ?>';
			
			console.log('ici fsave = ' + fsave+' et viewid = '+viewid+' et view = '+view+' et fieldid = '+fieldid);
			jQuery.ajax({
				url: "<?php echo JURI::root().'index.php?option=com_ajax&plugin=content_menu_dynamic&group=cck_field_link&format=json';?>",
				type: "POST",
				dataType: "json",
				data: {task: "_getCustomConf",view: view,fieldId: fieldid,viewId: viewid},
				success: function(data) {
					var success = data["success"];
					defaultValue = data.data[0];
					console.log("new default value => "+defaultValue);
					readDefaultValue(defaultValue);
				}
			});
		}else{
			readDefaultValue(defaultValue);
		}
	}

	function readDefaultValue(defaultValue){
								
		var myarray = jQuery.parseJSON(defaultValue);
		var i =0;
	
		if(Array.isArray(myarray) && myarray.length > 0){
			jQuery.each( myarray, function( i, val ) {
				if(i>0){
					jQuery( ".multiple:last" ).clone().insertAfter(jQuery( ".multiple:last" ));
					var number = 1 + Math.floor(Math.random() * 999999999);
					jQuery( ".multiple:last" ).attr('id', 'v'+number);
					jQuery( ".kill:last" ).removeClass().addClass('kill v'+number);
				}
	
				
				// prepare alternance so, check for both property name			
				var arr = { 'groupUser' : 'gu','selectId': 'sId','itemId':'iId','contentType':'cT', 'filter_field' : 'ff', 'filter_field_value':'ffv'};
				for (var key in arr) {
					//var property = arr[key];
					val[arr[key]] = val[arr[key]] === undefined ? val[key] : val[arr[key]];
				}
				
				$('.groupUser:last').val(val.gu);
				$('.selectId:last').val(val.sId);
				$('.menuItem:last').val(val.iId);
				$('.celCck:last').val(val.cT);
				$('.filter_field:last').val(val.ff);
				
				$('.filter_field_value:last').val(val.ffv);
				
				i++;
			})
		}
	
		$('#itemid').isDisabledWhen('sef','0');
		$('#content_fieldname,#content_location,#blank_li').isVisibleWhen('content','2');
	
		addEvents();
	}


	function addEvents()
	{
		jQuery('.button-del').click(function(event) {
			defoncezMoi(jQuery(this));
			event.stopPropagation();
			return false;
		});
		
		jQuery('.button-add').click(function(event) {
			multipliezMoi(jQuery(this));
			event.stopPropagation();
			return false;
		});
		
		jQuery("#sortable").sortable();
	    //jQuery( "#sortable" ).disableSelection();
	}


	$('#bool').change(function(){
		modifCode();
	});
	$('#isFcode').change(function(){
		modifIsFCode();
	});
	$('#bool4').change(function(){
		modifDynamic();
	});

	var isDynamic = modifDynamic();
	var isCode = modifCode();

	//jQuery('#itemid').isDisabledWhen('sef','0');
	//jQuery('#itemid_fieldname,#blank_li2').isVisibleWhen('itemid','-2');
	//jQuery('#sortable_core_dev_texts').isVisibleWhen('itemid','-3');
	//jQuery('#content_fieldname,#content_location,#blank_li').isVisibleWhen('content','2');

	
	
});
</script>
